<template>
  <div class="programs-detail-page">
    <ProgramOverviewSection :title="program_data.title" :tabs="overview_tabs" />
    <SliderImages
      v-if="overview_slider_images.length > 0"
      :images="overview_slider_images"
    />
    <DynamicSection :data="program_data.overviews" />
    <StudentWorkSection
      id="student-archive"
      v-if="student_works.length > 0"
      :student_works="student_works"
    />
    <SectionTitle id="curriculum" :title="program_data.curriculum_header" />
    <DynamicSection :data="curriculum_overviews" />
    <ProgramCurriculumSection :program_data="program_data" />
    <template v-if="people_data.length > 0">
      <SectionTitle id="people" :title="program_data.people_header" />
      <PeopleList :data="people_data" />
    </template>
    <template v-if="career_data.length > 0">
      <SectionTitle id="career-alumni" :title="program_data.career_header" />
      <PeopleList :data="career_data" />
    </template>
    <GetInTouch
      id="apply"
      :title="program_data.application_header"
      link="/application"
      link_text="Apply now"
    />
    <DynamicSection :data="tuition_overviews" />
    <!-- <StudentWorkSection
      :student_works="think_about_works"
      theme_color="#d00000"
    /> -->
    <!-- <ProgramCollapseSection :collapse_list="collapse_list" /> -->
    <!-- <ExplainSection :data="apply_list" /> -->
    <!-- <SectionTitle
      v-if="program_data.fees_funding_header"
      :title="program_data.fees_funding_header"
    /> -->
    <!-- <ProgramFeeSection :program_data="program_data" /> -->
    <ProgramEndSection :program_data="program_data" />
  </div>
</template>

<script>
import _ from "lodash";
import qs from "qs";

export default {
  async asyncData({ params, $appApi }) {
    const query = qs.stringify(
      {
        populate: [
          "image_1",
          "image_2",
          "overview_slider_images",
          "careers.photo",
          "peoples.photo",
          "student_archives.image",
          "student_archives.program",
          "overviews",
          "overviews.image",
          "curriculum_image",
          "scholarship_undergrad.file",
          "scholarship_postgrad.file",
          "tuition_undergrad.file",
          "tuition_postgrad.file",
          "curriculum_undergrad",
          "curriculum_postgrad",
          "tuition_image",
        ],
      },
      {
        encodeValuesOnly: true,
      }
    );

    try {
      const res = await $appApi.get(`/programs/${params.id}?${query}`);
      const program_data = _.get(res, "data.attributes", {});
      const overviews_data = _.get(program_data, "overviews.data");
      const overviews = _.map(overviews_data, (d) => ({
        ...d.attributes,
      }));

      return {
        program_data: {
          ...program_data,
          id: res?.data?.id,
          overviews: _.flatten(overviews),
        },
      };
    } catch (error) {
      console.log(error);
    }

    return { program_data: {} };
  },
  head({ $config }) {
    return {
      title: `Programs - ${this.program_data.title} - ${$config.title}`,
    };
  },
  data() {
    return {
      student_works: [],
      people_data: [],
      career_data: [],
      think_about_works: [],
      collapse_list: [],
    };
  },
  computed: {
    _() {
      return _;
    },
    overview_tabs() {
      let data = [
        {
          id: "#overview",
          name: _.get(this.program_data, "overview_menu_1"),
        },
        {
          id: "#student-archive",
          name: _.get(this.program_data, "overview_menu_2"),
        },
        {
          id: "#curriculum",
          name: _.get(this.program_data, "overview_menu_3"),
        },
        {
          id: "#people",
          name: _.get(this.program_data, "overview_menu_4"),
        },
        {
          id: "#career-alumni",
          name: _.get(this.program_data, "overview_menu_5"),
        },
        {
          id: "#apply",
          name: _.get(this.program_data, "overview_menu_6"),
        },
      ];
      data = _.filter(data, (d) => d.name);
      return data;
    },
    overview_slider_images() {
      return _.map(
        _.get(this.program_data, "overview_slider_images.data"),
        (d) => {
          return process.env.api_url + _.get(d, "attributes.url");
        }
      );
    },
    curriculum_overviews() {
      const data = [
        {
          type: "image",
          image: _.get(this.program_data, "curriculum_image"),
        },
        {
          type: "rich text",
          detail: _.get(this.program_data, "curriculum_detail"),
        },
      ];
      return data;
    },
    tuition_overviews() {
      const data = [
        {
          type: "image",
          image: _.get(this.program_data, "tuition_image"),
        },
        {
          type: "rich text",
          detail: _.get(this.program_data, "tuition_detail"),
        },
      ];
      return data;
    },
    why_data() {
      return [
        {
          id: 1,
          type: "text",
          title: _.get(this.program_data, "header_overview"),
          description: _.get(this.program_data, "overview"),
        },
        {
          id: 2,
          type: "image",
          image:
            process.env.api_url +
            _.get(this.program_data, "image_2.data.attributes.url"),
        },
      ];
    },
    apply_list() {
      const image = {
        id: 2,
        type: "image",
        image: require("~/assets/images/img.webp"),
      };
      const image_2 = {
        id: 3,
        type: "image",
        image: require("~/assets/images/img_1.webp"),
      };
      const process_header = {
        id: 1,
        type: "text",
        title: _.get(this.program_data, "application_process_header"),
        description: _.get(this.program_data, "application_process"),
      };
      const admitted_header = {
        id: 4,
        type: "text",
        title: _.get(this.program_data, "after_you_are_admitted_header"),
        description: _.get(this.program_data, "after_you_are_admitted"),
      };
      return this.$mq === "mobile"
        ? [image, process_header, admitted_header]
        : [process_header, image, image_2, admitted_header];
    },
  },
  mounted() {
    this.setStudentWorks();
    this.setPeopleData();
    this.setCareerData();
    this.setThinkAboutWorks();
    this.setCollapseList();
  },
  methods: {
    setStudentWorks() {
      this.student_works =
        _.get(this.program_data, "student_archives.data") || [];
      // if (this.student_works.length > 2) {
      //   const work = {
      //     id: "work",
      //     type: "arrow",
      //     title:
      //       "Thammasat Design School enables students to develop the knowledge and skills they need to succeed in and contribute to our rapidly changing society.",
      //   };
      //   this.student_works.splice(2, 0, work);
      // }
    },
    setPeopleData() {
      const people_data = _.get(this.program_data, "peoples.data");
      this.people_data = _.map(people_data, (d) => {
        let level_order;
        const level = _.get(d, "attributes.level");
        if (level === "head-program") level_order = 1;
        if (level === "associate-head-program") level_order = 2;
        if (level === "professor") level_order = 3;
        if (level === "associate-professor") level_order = 4;
        if (level === "assistant-professor") level_order = 5;
        if (level === "instructor") level_order = 6;
        if (level === "staff") level_order = 7;
        return {
          ...d,
          th_name: _.get(d, "attributes.th_name"),
          en_name: _.get(d, "attributes.en_name"),
          position: _.get(d, "attributes.position"),
          company: _.get(d, "attributes.company"),
          biography: _.get(d, "attributes.biography"),
          image:
            process.env.api_url +
            _.get(d, "attributes.photo.data.attributes.url"),
          level_order,
        };
      });
      this.people_data = _.orderBy(
        this.people_data,
        ["level_order", "en_name"],
        ["asc", "asc"]
      );
    },
    setCareerData() {
      const career_data = _.get(this.program_data, "careers.data");
      this.career_data = _.map(career_data, (d) => {
        return {
          ...d,
          th_name: _.get(d, "attributes.th_name"),
          en_name: _.get(d, "attributes.en_name"),
          position: _.get(d, "attributes.position"),
          company: _.get(d, "attributes.company"),
          biography: _.get(d, "attributes.biography"),
          image:
            process.env.api_url +
            _.get(d, "attributes.photo.data.attributes.url"),
        };
      });
    },
    setThinkAboutWorks() {
      this.think_about_works = [
        {
          id: "text",
          type: "text",
          title: _.get(this.program_data, "thinking_about_applying_header"),
          description: _.get(this.program_data, "thinking_about_applying"),
        },
        {
          id: "work",
          type: "arrow",
          title:
            "Thammasat Design School enables students to develop the knowledge and skills they need to succeed in and contribute to our rapidly changing society.",
        },
      ];
    },
    setCollapseList() {
      this.collapse_list = [
        {
          title: _.get(this.program_data, "entry_requirement_header"),
          text: _.get(this.program_data, "entry_requirement"),
        },
        {
          title: _.get(
            this.program_data,
            "english_language_requirements_header"
          ),
          text: _.get(this.program_data, "english_language_requirements"),
        },
        {
          title: _.get(this.program_data, "selection_criteria_header"),
          text: _.get(this.program_data, "selection_criteria"),
        },
        {
          title: _.get(this.program_data, "personal_statement_header"),
          text: _.get(this.program_data, "personal_statement"),
        },
        {
          title: _.get(this.program_data, "portfolio_header"),
          text: _.get(this.program_data, "portfolio"),
        },
      ];
      this.collapse_list = _.filter(this.collapse_list, (c) => c.title);
    },
  },
};
</script>

<style lang="scss" scoped></style>
